<template>
  <textarea
    :id="id"
    ref="target"
    :value="modelValue"
    class="w-full flex-1 resize-none border-b border-slate-100 font-normal leading-6 antialiased outline-none transition-colors focus-visible:border-fuchsia-500 focus-visible:outline-0 hover:[&:not(:focus-visible)]:border-slate-400"
    placeholder="Task"
    rows="1"
    autocomplete="on"
    spellCheck
    wrap="hard"
    @blur="updateModelValue"
    @keydown="trySetAutoHeight"
  />
</template>

<script lang="ts" setup>
import { useResizeObserver } from '@vueuse/core';

defineProps<{
  id: string;
  modelValue: string;
}>();
const emit = defineEmits<{
  (e: 'update:modelValue', id: string): void;
}>();

const updateModelValue = (e: Event) => {
  e.preventDefault();
  const { value } = e.target as HTMLInputElement;
  emit('update:modelValue', value);
};

const target = ref<HTMLTextAreaElement>();
const trySetAutoHeight = () => {
  const el = target.value;
  if (!el) {
    return;
  }
  const currentHeight = parseInt(el.style.height);
  if (currentHeight !== el.scrollHeight) {
    el.style.height = '1px';
    el.style.height = el.scrollHeight + 2 + 'px';
  }
};
onMounted(() => {
  trySetAutoHeight();
});

useResizeObserver(target, () => {
  trySetAutoHeight();
});
</script>
